using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations.Schema;

namespace IRaCIS.Core.Domain.Models
{
    [Table("Site")]
    public partial class Site : Entity, IAuditUpdate, IAuditAdd
    {
        [JsonIgnore]
        public Hospital Hospital { get; set; }
        public string SiteName { get; set; }

        public string AliasName { get; set; } = string.Empty;
        public string SiteCode { get; set; }

        public int Code { get; set; }

        public string City { get; set; }
        public string Country { get; set; }
        public Guid? HospitalId { get; set; } 
        public int State { get; set; }

        public string UniqueCode { get; set; } = string.Empty;

        public string Address { get; set; }

        public string DirectorName { get; set; } = string.Empty;
        public string DirectorPhone { get; set; } = string.Empty;
        public string ContactName { get; set; } = string.Empty;
        public string ContactPhone { get; set; } = string.Empty;

        public Guid CreateUserId { get; set; } = Guid.Empty;
        public DateTime CreateTime { get; set; } = DateTime.Now;
        public Guid UpdateUserId { get; set; } = Guid.Empty;
        public DateTime UpdateTime { get; set; } = DateTime.Now;
        [JsonIgnore]
        public List<Subject> SubjectList { get; set; }

        //
        [JsonIgnore]
        public List<TrialSite> TrialSiteList { get; set; }
        [JsonIgnore]
        public List< TrialSiteUser> TrialSiteUserList { get; set; }
    }
}
